mod Maux

incl Mtex

rem 
  \para \bf  Integer square root.  \end 
  \eq* 
    Sq Tex_f1_n_sqrt(x) <= x & x < Sq(Tex_f1_n_sqrt(x)+1)
  \end

fun Sgn 'Tex_f1_n_sgn'
  Sgn(0) = 0
  Sgn(x) = 1 <- x != 0

fun Sqrt 'Tex_f1_n_sqrt'
  Sqrt(x) = Sgn(z) <- x = 4*y+z & 0 <= z & z <= 3 & y = 0
  Sqrt(x) = r <- 
    x = 4*y+z & 0 <= z & z <= 3 & y != 0 & 2*Sqrt(y) = r & x < Sq(r+1)
  Sqrt(x) = r+1 <- 
    x = 4*y+z & 0 <= z & z <= 3 & y != 0 & 2*Sqrt(y) = r & x >= Sq(r+1)

rem 
  \para \bf  Fibonacci numbers.  \end 

fun Fib 'Tex_f1_n_fib'
  Fib(0) = 0
  Fib(1) = 1
  Fib(n+2) = Fib(n+1)+Fib(n)

